/* Copyright 2017 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

function _toConsumableArray(arr) {
 if (Array.isArray(arr)) {
  for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
   arr2[i] = arr[i];
  }
  return arr2;
 } else {
  return Array.from(arr);
 }
}
var selectByMinimalShift = function selectByMinimalShift(array, value) {
 var shifts = array.map(function (val) {
  return Math.abs(val - value);
 });
 return array[shifts.indexOf(Math.min.apply(Math, _toConsumableArray(shifts)))];
};
var scrollToNode = function (node) {
 var nodeBCR = node.getBoundingClientRect();
 var container = document.getElementById('viewerContainer');
 var wrapperBCR = document.body.getBoundingClientRect();
 var scrollTop = container.scrollTop;
 var scrollLeft = container.scrollLeft;
 var workspaceHeight = wrapperBCR.height;
 var workspaceWidth = wrapperBCR.width;
 var frameBounding = {
  top: container.scrollTop,
  left: container.scrollLeft,
  right: workspaceWidth + container.scrollLeft,
  bottom: workspaceHeight + container.scrollTop
 };
 var elementBounding = {
  top: nodeBCR.top + scrollTop - 30,
  bottom: nodeBCR.bottom + scrollTop + 30,
  left: nodeBCR.left + scrollLeft - 30,
  right: nodeBCR.right + scrollLeft + 30,
  height: nodeBCR.height + 60,
  width: nodeBCR.width + 60
 };
 var isСompletelyInvisibleElement = elementBounding.bottom <= frameBounding.top || elementBounding.right <= frameBounding.left || elementBounding.left >= frameBounding.right || elementBounding.top >= frameBounding.bottom;
 var isTopLeftInvisible = elementBounding.left < frameBounding.left || elementBounding.top < frameBounding.top;
 var isTopRightInvisible = elementBounding.top < frameBounding.top || elementBounding.right > frameBounding.right;
 var isBottomLeftInvisible = elementBounding.bottom > frameBounding.bottom || elementBounding.left < frameBounding.left;
 var isBottomRightInvisible = elementBounding.bottom > frameBounding.bottom || elementBounding.right > frameBounding.right;
 var newScrollTop = scrollTop;
 var newScrollLeft = scrollLeft;
 if (isBottomRightInvisible && isTopRightInvisible || isTopLeftInvisible && isBottomLeftInvisible) {
  var newScrollLeftByLeft = elementBounding.left;
  var newScrollLeftByRight = elementBounding.right - workspaceWidth;
  newScrollLeftByRight = newScrollLeftByRight < 0 ? 0 : newScrollLeftByRight;
  var newScrollLeftByCenter = elementBounding.left + elementBounding.width / 2 - workspaceWidth / 2;
  newScrollLeftByCenter = newScrollLeftByCenter < 0 ? 0 : newScrollLeftByCenter;
  var newScrollLeftMinimalShift = selectByMinimalShift([
   newScrollLeftByLeft,
   newScrollLeftByRight,
   newScrollLeftByCenter
  ], scrollLeft);
  newScrollLeft = elementBounding.width < workspaceWidth ? newScrollLeftMinimalShift : newScrollLeftByCenter;
 }
 if (isBottomRightInvisible && isBottomLeftInvisible || isTopRightInvisible && isTopLeftInvisible) {
  var newScrollTopByTop = elementBounding.top;
  var newScrollTopByBottom = elementBounding.bottom - workspaceHeight;
  newScrollTopByBottom = newScrollTopByBottom < 0 ? 0 : newScrollTopByBottom;
  var newScrollTopByMiddle = elementBounding.top + elementBounding.height / 2 - workspaceHeight / 2;
  newScrollTopByMiddle = newScrollTopByMiddle < 0 ? 0 : newScrollTopByMiddle;
  var newScrollTopMinimalShift = selectByMinimalShift([
   newScrollTopByTop,
   newScrollTopByBottom,
   newScrollTopByMiddle
  ], scrollTop);
  newScrollTop = elementBounding.height < workspaceHeight ? newScrollTopMinimalShift : newScrollTopByMiddle;
 }
 if (isСompletelyInvisibleElement || isBottomRightInvisible || isTopRightInvisible || isTopRightInvisible || isTopLeftInvisible) {
  document.getElementById('viewerContainer').scrollTop = newScrollTop;
  document.getElementById('viewerContainer').scrollLeft = newScrollLeft;
 }
};
var drawRegion = function (region, index, counter) {
 var pageId = region.pageIndex + 1;
 var id = region.id;
 var div = document.querySelector(`.areas[data-page-number="${ pageId }"]`);
 var area = document.querySelector(`.regionArea[data-region-id="${ id }"]`);
 if (counter >= 10)
  return;
 if (!div) {
  setTimeout(drawRegion, 1000, region, index, counter + 1);
  return;
 }
 if (area)
  return;
 var bounds = region.bounds;
 var node = document.createElement('div');
 node.className = 'regionArea';
 node.dataset.regionId = id;
 node.dataset.index = index;
 node.style.left = bounds.left * 96 + 'px';
 node.style.top = bounds.top * 96 + 'px';
 if (window.jsfocrData.selectedRegion.indexOf(region.id) !== -1) {
  node.className = 'regionArea active';
 }
 node.style.width = (bounds.right - bounds.left) * 96 + 'px';
 node.style.height = (bounds.bottom - bounds.top) * 96 + 'px';
 div.appendChild(node);
 if (window.jsfocrData.selectedRegion.indexOf(region.id) !== -1) {
  scrollToNode(node);
 }
};
const changeActiveRegion = function () {
 var index = window.jsfocrData.selectedRegion;
 var areas = document.querySelectorAll(`.regionArea.active`);
 areas.forEach(function (area) {
  area.className = 'regionArea';
 });
 window.jsfocrData.selectedRegion.forEach(index => {
  var area = document.querySelector(`.regionArea[data-region-id="${ index }"]`);
  if (area) {
   area.className = 'regionArea active';
   scrollToNode(area);
  }
 });
};
var drawRegions = function () {
 window.jsfocrData.regions.reverse().forEach(function (region, index) {
  drawRegion(region, index, 0);
 });
};
var reset = function () {
 window.jsfocrData = {
  regions: [],
  selectedRegion: -1
 };
 var nodesArray = Array.prototype.slice.call(document.querySelectorAll('.regionArea'));
 nodesArray.map(function (node) {
  node.remove();
 });
};
window.addEventListener('message', function onMessage(event) {
 if (event.data.regions) {
  window.jsfocrData = {
   regions: event.data.regions,
   selectedRegion: event.data.selectedRegion !== false ? event.data.selectedRegion : -1
  };
  drawRegions();
 }
 if (event.data.reset) {
  reset();
 }
 if (typeof event.data.selectedRegionChanged !== 'undefined') {
  window.jsfocrData.selectedRegion = event.data.selectedRegionChanged;
  changeActiveRegion();
 }
});
parent.postMessage('i\'m loaded', '*');

/***/ })
/******/ ]);